searchData={"items":[{"type":"module","title":"BeamBenchmarks","doc":"BEAM Benchmarks\n\nSee functions for supported benchmarks.","ref":"BeamBenchmarks.html"},{"type":"function","title":"BeamBenchmarks.bang/1","doc":"Run bencherl's bang test\n\nA benchmark for many-to-one message passing that spawns one receiver and\nmultiple senders that flood the receiver with messages.","ref":"BeamBenchmarks.html#bang/1"},{"type":"type","title":"BeamBenchmarks.bencherl_options/0","doc":"Options for running bencherl tests\n\n* `version` - run a `:short`, `:intermediate`, `:long` version. Default is `:short`.\n* `number_of_cores` - the number of cores to use. Default is the number of schedulers.","ref":"BeamBenchmarks.html#t:bencherl_options/0"},{"type":"type","title":"BeamBenchmarks.bencherl_version/0","doc":"","ref":"BeamBenchmarks.html#t:bencherl_version/0"},{"type":"function","title":"BeamBenchmarks.big/1","doc":"Run bencherl's big test\n\nA benchmark that implements a many-to-many message passing scenario.","ref":"BeamBenchmarks.html#big/1"},{"type":"function","title":"BeamBenchmarks.device_info/0","doc":"Return information about the device","ref":"BeamBenchmarks.html#device_info/0"},{"type":"function","title":"BeamBenchmarks.ehb/1","doc":"Run bencherl's ehb test\n\nThis is an implementation of *hackbench* in Erlang, a benchmark and stress\ntest for Linux schedulers.","ref":"BeamBenchmarks.html#ehb/1"},{"type":"function","title":"BeamBenchmarks.estone/1","doc":"Run estone_SUITE and pretty print the results\n\nThis is a suite of benchmarks that measure performance of various Erlang\nprimitives.\n\nSee `estone_bench/1` for machine readable results.","ref":"BeamBenchmarks.html#estone/1"},{"type":"function","title":"BeamBenchmarks.estone_bench/1","doc":"Run estone_SUITE benchmarks\n\nThis is a suite of benchmarks that measure performance of various Erlang\nprimitives.","ref":"BeamBenchmarks.html#estone_bench/1"},{"type":"type","title":"BeamBenchmarks.estone_options/0","doc":"","ref":"BeamBenchmarks.html#t:estone_options/0"},{"type":"function","title":"BeamBenchmarks.ets_random_ops/1","doc":"Run bencherl's ets_random_ops test\n\nThis benchmark creates an ETS table and spawns several readers and writers\nthat perform a certain number of reads (lookups) and writes (inserts),\nrespectively, to that table.","ref":"BeamBenchmarks.html#ets_random_ops/1"},{"type":"function","title":"BeamBenchmarks.ets_test/1","doc":"Run bencherl's ets_test test\n\nThis benchmark creates an ETS table and spawns several readers and writers\nthat perform a certain number of reads (lookups) and writes (inserts),\nrespectively, to that table.","ref":"BeamBenchmarks.html#ets_test/1"},{"type":"function","title":"BeamBenchmarks.genstress/1","doc":"Run bencherl's genstress test\n\nThis is a generic server benchmark that spawns an echo server and a number of\nclients.","ref":"BeamBenchmarks.html#genstress/1"},{"type":"function","title":"BeamBenchmarks.mbrot/1","doc":"Run bencherl's mbrot test\n\nThis benchmark extrapolates the coordinates of a 2-D complex plane that\ncorrespond to the pixels of a 2-D image of a specific resolution.","ref":"BeamBenchmarks.html#mbrot/1"},{"type":"function","title":"BeamBenchmarks.moves/1","doc":"Run bencherl's moves test\n\nParallel benchmark program that solves the moves problem. A description of\nthe moves problem can be found in the ETS implementation report that can be\nfound here:\n\nhttps://github.com/kjellwinblad/ets_impl_project","ref":"BeamBenchmarks.html#moves/1"},{"type":"function","title":"BeamBenchmarks.orbit_int/1","doc":"Run bencherl's orbit_int test\n\nThis benchmark operates on a distributed hash table, and follows a\nmaster/worker architecture.","ref":"BeamBenchmarks.html#orbit_int/1"},{"type":"function","title":"BeamBenchmarks.parallel/1","doc":"Run bencherl's parallel test\n\nA benchmark for parallel execution that spawns a number of processes, each of\nwhich creates a list of $N$ timestamps and, after it checks that each element\nof the list is strictly greater than its previous one (as promised by the\nimplementation of erlang:now/0), it sends the result to its parent.","ref":"BeamBenchmarks.html#parallel/1"},{"type":"function","title":"BeamBenchmarks.pcmark/1","doc":"Run bencherl's pcmark test\n\nThis benchmark is also about ETS operations. It creates five ETS tables,\nfills them with values, and then spawns a certain number of processes that\nread the contents of those tables and update them. As soon as one process\nfinishes, a new process is spawned, until a certain total number of processes\nhas been reached. The benchmark is parameterized by the number of initial\nprocesses and the total number of processes.","ref":"BeamBenchmarks.html#pcmark/1"},{"type":"function","title":"BeamBenchmarks.ran/1","doc":"Run bencherl's ran test\n\nAnother benchmark for parallel execution that spawns a certain number of\nprocesses, each of which generates a list of ten thousand random integers,\nsorts it and sends its first half to the parent process. The benchmark\nreceives the number of processes as a parameter.","ref":"BeamBenchmarks.html#ran/1"},{"type":"function","title":"BeamBenchmarks.run_bencherl_test/2","doc":"","ref":"BeamBenchmarks.html#run_bencherl_test/2"},{"type":"function","title":"BeamBenchmarks.run_bencherl_tests/1","doc":"Run all bencherl tests","ref":"BeamBenchmarks.html#run_bencherl_tests/1"},{"type":"function","title":"BeamBenchmarks.serialmsg/1","doc":"Run bencherl's serialmsg test\n\nA benchmark about message proxying through a dispatcher. The benchmark spawns\na certain number of receivers, one dispatcher, and a certain number of\ngenerators. The dispatcher forwards the messages that it receives from\ngenerators to the appropriate receiver. Each generator sends a number of\nmessages to a specific receiver.","ref":"BeamBenchmarks.html#serialmsg/1"},{"type":"function","title":"BeamBenchmarks.timer_wheel/1","doc":"Run bencherl's timer_wheel test\n\nA timer management benchmark that spawns a certain number of processes that\nexchange *ping* and *pong* messages.","ref":"BeamBenchmarks.html#timer_wheel/1"},{"type":"module","title":"BeamBenchmarks.Info","doc":"Utilities for returning information about the device","ref":"BeamBenchmarks.Info.html"},{"type":"function","title":"BeamBenchmarks.Info.all_info/0","doc":"","ref":"BeamBenchmarks.Info.html#all_info/0"},{"type":"type","title":"BeamBenchmarks.Info.t/0","doc":"","ref":"BeamBenchmarks.Info.html#t:t/0"},{"type":"extras","title":"BeamBenchmarks","doc":"# BeamBenchmarks\n\n[![Hex version](https://img.shields.io/hexpm/v/beam_benchmarks.svg \"Hex version\")](https://hex.pm/packages/beam_benchmarks)\n[![API docs](https://img.shields.io/hexpm/v/beam_benchmarks.svg?label=hexdocs \"API docs\")](https://hexdocs.pm/beam_benchmarks/doc/BeamBenchmarks.html)\n[![CircleCI](https://dl.circleci.com/status-badge/img/gh/fhunleth/beam_benchmarks/tree/main.svg?style=svg)](https://dl.circleci.com/status-badge/redirect/gh/fhunleth/beam_benchmarks/tree/main)\n\nThis is a collection of Erlang benchmarks copied from other projects for ease of\nuse. This project makes these benchmarks a hex dependency and helper function\naway. Some documentation is copied here for convenience, but please see\nthe source projects for more complete information.\n\nBenchmarks include:\n\nName   | Source   | Description\n------ | -------- | -----------\n`bang` | [bencherl][bencherl] |\tA benchmark for many-to-one message passing that spawns one receiver and multiple senders that flood the receiver with messages.\n`big`  | [bencherl][bencherl] | A benchmark that implements a many-to-many message passing scenario.\n`ehb`  | [bencherl][bencherl] |\tThis is an implementation of *hackbench* in Erlang, a benchmark and stress test for Linux schedulers.\n`ets_test` | [bencherl][bencherl] | This benchmark creates an ETS table and spawns several readers and writers that perform a certain number of reads (lookups) and writes (inserts), respectively, to that table.\n`genstress` | [bencherl][bencherl] | This is a generic server benchmark that spawns an echo server and a number of clients.\n`mbrot` | [bencherl][bencherl] | This benchmark extrapolates the coordinates of a 2-D complex plane that correspond to the pixels of a 2-D image of a specific resolution.\n`orbit_int` | [bencherl][bencherl] | This benchmark operates on a distributed hash table, and follows a master/worker architecture.\n`parallel`  | [bencherl][bencherl] | A benchmark for parallel execution that spawns a number of processes, each of which creates a list of $N$ timestamps and, after it checks that each element of the list is strictly greater than its previous one (as promised by the implementation of erlang:now/0), it sends the result to its parent.\n`pcmark` | [bencherl][bencherl] | This benchmark is also about ETS operations. It creates five ETS tables, fills them with values, and then spawns a certain number of processes that read the contents of those tables and update them. As soon as one process finishes, a new process is spawned, until a certain total number of processes has been reached. The benchmark is parameterized by the number of initial processes and the total number of processes.\n`ran` | [bencherl][bencherl] | Another benchmark for parallel execution that spawns a certain number of processes, each of which generates a list of ten thousand random integers, sorts it and sends its first half to the parent process. The benchmark receives the number of processes as a parameter.\n`serialmsg` | [bencherl][bencherl] | A benchmark about message proxying through a dispatcher. The benchmark spawns a certain number of receivers, one dispatcher, and a certain number of generators. The dispatcher forwards the messages that it receives from generators to the appropriate receiver. Each generator sends a number of messages to a specific receiver.\n`timer_wheel` | [bencherl][bencherl] | A timer management benchmark that spawns a certain number of processes that exchange *ping* and *pong* messages.\n`estone` | [estone_SUITE.erl][estone_SUITE.erl] | This is a suite of benchmarks that measure performance of various Erlang primitives.\n\n[bencherl]: https://github.com/softlab-ntua/bencherl\n[estone_SUITE.erl]: https://github.com/erlang/otp/blob/maint-27/erts/emulator/test/estone_SUITE.erl","ref":"readme.html"},{"type":"extras","title":"Installation - BeamBenchmarks","doc":"Adding `beam_benchmarks` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n      {:beam_benchmarks, \"~> 0.1\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Sample run - BeamBenchmarks","doc":"```elixir\niex> BeamBenchmarks.estone\nEStone test completed\n**** CPU speed UNKNOWN MHz ****\n**** Total time 0.95421 seconds ****\n**** ESTONES = 696638 ****\n\n    Title                            Millis        Estone       %    Loops\n\n{'ESTONES',696638}\nlist manipulation                    55              27511        7     6400\nsmall messages                       215             14442        10    1515\nmedium messages                      220             27669        14    1527\nhuge messages                        25              19659        4     52\npattern matching                     8               102649       5     1046\ntraverse                             18              26960        4     2834\nPort i/o                             153             29175        12    4800\nWork with large dataset              13              21564        3     1193\nWork with large local dataset        13              22174        3     1174\nAlloc and dealloc                    4               35418        2     3710\nBif dispatch                         12              162170       8     5623\nBinary handling                      34              14654        4     581\nets datadictionary                   34              32825        6     342\nGeneric server (with timeout)        114             22092        9     7977\nSmall Integer arithmetics            9               32213        3     4157\nFloat arithmetics                    2               14790        1     5526\nFunction calls                       12              62344        5     882\nTimers                               13              9553         2     2312\nLinks                                2               18776        1     30\n{:comment, 'UNKNOWN MHz, 696638 ESTONES'}\n```","ref":"readme.html#sample-run"},{"type":"extras","title":"Licensing - BeamBenchmarks","doc":"Please see the individual source files for their licenses.","ref":"readme.html#licensing"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"changelog.html"},{"type":"extras","title":"v0.1.0 - Changelog","doc":"Initial release. Benchmarks should all compile and run on Elixir 1.18 and\nErlang/OTP 27.","ref":"changelog.html#v0-1-0"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.36.1"}}